
<p>Uporabom poluvodičkih dioda izravno možemo ostvariti sklopove I i ILI. Imena funkcija koja ćemo davati implementacijama prikazanim u nastavku podrazumijevaju interpretaciju u pozitivnoj logici, pa to kasnije nećemo posebno naglašavati.</p>

<h3>Diodni sklop I</h3>

<p>Implementacija diodnog sklopa I prikazana je na slici 1.</p>

<figure class="mlFigure">
<img src="@#file#(diodniI.svg)" alt="Dvoulazni diodni sklop I."><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Dvoulazni diodni sklop I.</figcaption>
</figure>

<p>Da bismo razumjeli rad ovog sklopa, potrebno je prisjetiti se kako se ponaša poluvodička dioda - taj je dio pojašnjen u posebnoj minilekciji, a ovdje ćemo se samo podsjetiti da poluvodička dioda u jednom smjeru uopće ne vodi (ako je polarizirana nepropusno) a u drugom smjeru ne vodi dok je napon na njoj manji od napona praga (primjerice 0,7V), a ako se dovede napon koji je veći od toga, dioda će provesti i na sebi održavati tih 0,7V; sva preostala razlika trošit će se na otporniku koji je spojen u seriju s diodom.</p>

<p>Pretpostavimo da želimo ispitati rad ovog sklopa pri čemu ćemo na ulaze A i B dovoditi nizak napon (koristit ćemo 0V odnosno masu) te visok napon (koristit ćemo 5V).</p>

<p>Interaktivna simulacija rada ovog sklopa dana je u nastavku. Klikom miša moguće je mijenjati logičke vrijednosti koje se dovode na ulaze. Simulacija prikazuje padove napona na svim elementima kao i animirani tok struje.</p>

<script>
@#page-include#(Utility.js)
@#page-include#(DiodeCircuits.js)
</script>

<div style="text-align: center;">
<canvas id="diodeANDCanvas"  width="500" height="300" style="border: solid 1px black"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Leon Luttenberger</span>
</div>

<script>
(function(){
        var canvas = document.getElementById("diodeANDCanvas");
        var context = canvas.getContext("2d");

        var lineLength = 30;
        var inputSize = 25;
        var fontSize = 20;

        var circuit = new DiodeANDCircuit(0.7, 0, 5);
        var truthTable = new TruthTable('1', '0', function (a, b) {
            return a & b;
        });
        var inputA, inputB;

        repaint();

        canvas.addEventListener("click", function (e) {
            var pos = getMousePos(canvas, e);

            if (inputA.containsPoint(pos.x, pos.y)) {
                toggleA();
                repaint();
            }

            if (inputB.containsPoint(pos.x, pos.y)) {
                toggleB();
                repaint();
            }
        }, false);

        function repaint() {
            context.clearRect(0, 0, canvas.width, canvas.height);
            circuit.draw(context, 100, 35, 150, 200, true);

            context.moveTo(circuit.inputAConnector.x, circuit.inputAConnector.y);
            context.lineTo(circuit.inputAConnector.x - lineLength, circuit.inputAConnector.y);
            context.stroke();

            context.moveTo(circuit.inputBConnector.x, circuit.inputBConnector.y);
            context.lineTo(circuit.inputBConnector.x - lineLength, circuit.inputBConnector.y);
            context.stroke();

            var x = circuit.inputAConnector.x - lineLength - inputSize;
            inputA = new Rectangle(x, circuit.inputAConnector.y - inputSize / 2, inputSize, inputSize);
            inputB = new Rectangle(x, circuit.inputBConnector.y - inputSize / 2, inputSize, inputSize);

            context.strokeStyle = "black";
            context.fillStyle = "gray";
            inputA.draw(context, true);
            inputB.draw(context, true);

            context.fillStyle = "black";
            context.font =  fontSize + 'px Ariel';
            context.textAlign = "center";
            context.textBaseline = "middle";

            var valueA = circuit.inputA ? 1 : 0;
            context.fillText(
                    valueA + '',
                    inputA.x + inputA.width / 2,
                    inputA.y + inputA.height / 2
            );

            var valueB = circuit.inputB ? 1 : 0;
            context.fillText(
                    valueB + '',
                    inputB.x + inputB.width / 2,
                    inputB.y + inputB.height / 2
            );

            context.textBaseline = "bottom";
            context.fillText("A", circuit.inputAConnector.x - lineLength / 2, circuit.inputAConnector.y - 5);
            context.textBaseline = "top";
            context.fillText("B", circuit.inputBConnector.x - lineLength / 2, circuit.inputBConnector.y + 5);

            context.textBaseline = "middle";
            context.textAlign = "left";
            context.fillText(
                    "f=" + (circuit.output ? '1' : '0'),
                    circuit.outputConnector.x + 5,
                    circuit.outputConnector.y
            );

            var a = circuit.inputA;
            var b = circuit.inputB;

            var selectedRow;
            if (!a && !b) {
                selectedRow = 0;
            } else if (!a && b) {
                selectedRow = 1;
            } else if (a && !b) {
                selectedRow = 2;
            } else {
                selectedRow = 3;
            }

            truthTable.draw(context, 325, 15, 150, 250, selectedRow);
        }

        function toggleA() {
            if (circuit.inputA) {
                circuit.setInputA(false);
            } else {
                circuit.setInputA(true);
            }
        }

        function toggleB() {
            if (circuit.inputB) {
                circuit.setInputB(false);
            } else {
                circuit.setInputB(true);
            }
        }
})();
</script>

<p>Ispitajte što se dobiva na izlazu za sve četiri kombinacije ulaznih vrijednosti. Zapamtite pri tome da 0 na ulazu zapravo predstavlja spoj prema masi (pa se tim putem može zatvoriti strujni krug) a 1 na ulazu predstavlja spoj na izvor od 5V (koji tada uspostavlja strujni krug i može generirati struju).</p>

<p>Od svih kombinacija koje je moguće dovesti na ulaze, prokomentirat ćemo dvije. Desni kraj dioda otpornikom je pritegnut na napon napajanja (5V). Ako na oba ulaza dovedemo visoku naponsku razinu (također 5V), tada su potencijali na oba kraja diode jednaki, dioda ne vodi, i nigdje ne teče struja. Kako je izlazni napon jednak naponu napajanja <i>U</i> umanjenom za pad napona na otporniku, vrijedi:
$$
  U_f = U - I \cdot R = U - 0 \cdot R = U = 5V
$$
odnosno izlazni napon je također visok. U situaciji kada je jedan od ulaza spojen na nisu naponsku razinu (pretpostavimo masu) a drugi na visoku, kroz granu koju čine izvor napajanja, otpornik i dioda koja je spojena na nisku naponsku razinu, poteči će struja jer je ta dioda propusno polarizirana. Na njoj će se uspostaviti pad napona od 0,7V što je ujedno i napon koji vlada na izlazu sklopa. Pogledajte sada onu drugu diodu: s njezine lijeve strane je 5V a s desne strane 0,7V; na njoj vlada pad napona od 0,7V-5V=-4,3V; ta je dioda nepropusno polarizirana i kroz nju struja ne teče.</p>

<p>Tablica kombinacija naponskih razina koju ćemo dobiti, prikazana je u nastavku.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 1.</span> Tablica naponskih kombinacija</div>
<table class="mlTableCC mlTableVR2">
<thead>
<tr><th><i>U<sub>A</sub></i></th><th><i>U<sub>B</sub></i></th><th><i>U<sub>f</sub></i></th></tr>
</thead>
<tbody>
<tr><td>0V</td><td>0V</td><td>0V</td></tr>
<tr><td>0V</td><td>5V</td><td>0V</td></tr>
<tr><td>5V</td><td>0V</td><td>0V</td></tr>
<tr><td>5V</td><td>5V</td><td>5V</td></tr>
</tbody>
</table>

<p>Neka naponi koji su manji od 1V pripadaju području niskih naponskih razina a naponi koji su veći od 4V području visokih naponskih razina. Prethodnu tablicu tada možemo prikazati na sljedeći način.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 2.</span> Tablica naponskih kombinacija</div>
<table class="mlTableCC mlTableVR2">
<thead>
<tr><th><i>U<sub>A</sub></i></th><th><i>U<sub>B</sub></i></th><th><i>U<sub>f</sub></i></th></tr>
</thead>
<tbody>
<tr><td>N</td><td>N</td><td>N</td></tr>
<tr><td>N</td><td>V</td><td>N</td></tr>
<tr><td>V</td><td>N</td><td>N</td></tr>
<tr><td>V</td><td>V</td><td>V</td></tr>
</tbody>
</table>

<p>Interpretacijom u pozitivnoj logici dobivamo tablicu istinitosti prikazanu u tablici 3.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 3.</span> Interpretacija u pozitivnoj logici</div>
<table class="mlTableCC mlTableVR2">
<thead>
<tr><th><i>A</i></th><th><i>B</i></th><th><i>f</i></th></tr>
</thead>
<tbody>
<tr><td>0</td><td>0</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>0</td></tr>
<tr><td>1</td><td>0</td><td>0</td></tr>
<tr><td>1</td><td>1</td><td>1</td></tr>
</tbody>
</table>

<p>Slijedi da je Booleova funkcija koju ostvaruje diodni sklop prikazan na slici 1 upravo funkcija logičko I, odnosno:
$$
 f(A,B) = A \cdot B.
$$</p>

<h3>Diodni sklop ILI</h3>

<p>Implementacija diodnog sklopa ILI prikazana je na slici 2.</p>

<figure class="mlFigure">
<img src="@#file#(diodniILI.svg)" alt="Dvoulazni diodni sklop ILI."><br>
<figcaption><span class="mlFigKey">Slika 2.</span> Dvoulazni diodni sklop ILI.</figcaption>
</figure>

<p>Opet želimo ispitati rad prikazanog sklopa. Na ulaze A i B ćemo dovoditi nizak napon (koristit ćemo 0V odnosno masu) te visok napon (koristit ćemo 5V).</p>

<p>Interaktivna simulacija rada ovog sklopa dana je u nastavku. Klikom miša moguće je mijenjati logičke vrijednosti koje se dovode na ulaze. Simulacija prikazuje padove napona na svim elementima kao i animirani tok struje.</p>

<div style="text-align: center;">
<canvas id="diodeORCanvas"  width="500" height="300" style="border: solid 1px black"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Leon Luttenberger</span>
</div>

<script>
(function(){
    var canvas = document.getElementById("diodeORCanvas");
    var context = canvas.getContext("2d");

    var lineLength = 30;
    var inputSize = 25;
    var fontSize = 20;

    var circuit = new DiodeORCircuit(0.7, 0, 5);
    var truthTable = new TruthTable('1', '0', function (a, b) {
        return a | b;
    });
    var inputA, inputB;

    repaint();

    canvas.addEventListener("click", function (e) {
        var pos = getMousePos(canvas, e);

        if (inputA.containsPoint(pos.x, pos.y)) {
            toggleA();
            repaint();
        }

        if (inputB.containsPoint(pos.x, pos.y)) {
            toggleB();
            repaint();
        }
    }, false);

    function repaint() {
        context.clearRect(0, 0, canvas.width, canvas.height);
        circuit.draw(context, 100, 35, 150, 200, true);

        context.moveTo(circuit.inputAConnector.x, circuit.inputAConnector.y);
        context.lineTo(circuit.inputAConnector.x - lineLength, circuit.inputAConnector.y);
        context.stroke();

        context.moveTo(circuit.inputBConnector.x, circuit.inputBConnector.y);
        context.lineTo(circuit.inputBConnector.x - lineLength, circuit.inputBConnector.y);
        context.stroke();

        var x = circuit.inputAConnector.x - lineLength - inputSize;
        inputA = new Rectangle(x, circuit.inputAConnector.y - inputSize / 2, inputSize, inputSize);
        inputB = new Rectangle(x, circuit.inputBConnector.y - inputSize / 2, inputSize, inputSize);

        context.strokeStyle = "black";
        context.fillStyle = "gray";
        inputA.draw(context, true);
        inputB.draw(context, true);

        context.fillStyle = "black";
        context.font =  fontSize + 'px Ariel';
        context.textAlign = "center";
        context.textBaseline = "middle";

        var valueA = circuit.inputA ? 1 : 0;
        context.fillText(
                valueA + '',
                inputA.x + inputA.width / 2,
                inputA.y + inputA.height / 2
        );

        var valueB = circuit.inputB ? 1 : 0;
        context.fillText(
                valueB + '',
                inputB.x + inputB.width / 2,
                inputB.y + inputB.height / 2
        );

        context.textBaseline = "bottom";
        context.fillText("A", circuit.inputAConnector.x - lineLength / 2, circuit.inputAConnector.y - 5);
        context.textBaseline = "top";
        context.fillText("B", circuit.inputBConnector.x - lineLength / 2, circuit.inputBConnector.y + 5);

        context.textBaseline = "middle";
        context.textAlign = "left";
        context.fillText(
                "f=" + (circuit.output ? '1' : '0'),
                circuit.outputConnector.x + 5,
                circuit.outputConnector.y
        );

        var a = circuit.inputA;
        var b = circuit.inputB;

        var selectedRow;
        if (!a && !b) {
            selectedRow = 0;
        } else if (!a && b) {
            selectedRow = 1;
        } else if (a && !b) {
            selectedRow = 2;
        } else {
            selectedRow = 3;
        }

        truthTable.draw(context, 325, 15, 150, 250, selectedRow);
    }

    function toggleA() {
        if (circuit.inputA) {
            circuit.setInputA(false);
        } else {
            circuit.setInputA(true);
        }
    }

    function toggleB() {
        if (circuit.inputB) {
            circuit.setInputB(false);
        } else {
            circuit.setInputB(true);
        }
    }
})();
</script>

<p>Ispitajte što se dobiva na izlazu za sve četiri kombinacije ulaznih vrijednosti.</p>

<p>Tablica kombinacija naponskih razina koju ćemo dobiti, prikazana je u nastavku.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 4.</span> Tablica naponskih kombinacija</div>
<table class="mlTableCC mlTableVR2">
<thead>
<tr><th><i>U<sub>A</sub></i></th><th><i>U<sub>B</sub></i></th><th><i>U<sub>f</sub></i></th></tr>
</thead>
<tbody>
<tr><td>0V</td><td>0V</td><td>0V</td></tr>
<tr><td>0V</td><td>5V</td><td>5V</td></tr>
<tr><td>5V</td><td>0V</td><td>5V</td></tr>
<tr><td>5V</td><td>5V</td><td>5V</td></tr>
</tbody>
</table>

<p>Uz pretpostavku da naponi koji su manji od 1V pripadaju području niskih naponskih razina a naponi koji su veći od 4V području visokih naponskih razina, prethodnu tablicu možemo prikazati na sljedeći način.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 5.</span> Tablica naponskih kombinacija</div>
<table class="mlTableCC mlTableVR2">
<thead>
<tr><th><i>U<sub>A</sub></i></th><th><i>U<sub>B</sub></i></th><th><i>U<sub>f</sub></i></th></tr>
</thead>
<tbody>
<tr><td>N</td><td>N</td><td>N</td></tr>
<tr><td>N</td><td>V</td><td>V</td></tr>
<tr><td>V</td><td>N</td><td>V</td></tr>
<tr><td>V</td><td>V</td><td>V</td></tr>
</tbody>
</table>

<p>Interpretacijom u pozitivnoj logici dobivamo tablicu istinitosti prikazanu u tablici 6.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 6.</span> Interpretacija u pozitivnoj logici</div>
<table class="mlTableCC mlTableVR2">
<thead>
<tr><th><i>A</i></th><th><i>B</i></th><th><i>f</i></th></tr>
</thead>
<tbody>
<tr><td>0</td><td>0</td><td>0</td></tr>
<tr><td>0</td><td>1</td><td>1</td></tr>
<tr><td>1</td><td>0</td><td>1</td></tr>
<tr><td>1</td><td>1</td><td>1</td></tr>
</tbody>
</table>

<p>Slijedi da je Booleova funkcija koju ostvaruje diodni sklop prikazan na slici 2 upravo funkcija logičko ILI, odnosno:
$$
 f(A,B) = A + B.
$$</p>

<h3>Drugi diodni sklopovi</h3>

<div class="mlImportant">
<p>Samo diodnim sklopovima nije moguće ostvariti invertor, niti funkcije koje u sebi sadrže negaciju (poput NI i NILI). Za ostvarivanje sklopova koji obavljaju takve funkcije trebat ćemo poluvodičke tranzistore.</p>
</div> 



